﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data.OleDb;
using System.Data;
using C1.WPF.DataGrid;


namespace Wpf_DataGrid_PrintSelectedArea
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            OleDbConnection conn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=../../testDB.mdb");
            OleDbDataAdapter da = new OleDbDataAdapter("Select * From Employees", conn);
            DataSet ds = new DataSet();
            da.TableMappings.Add("Table", "Employees");
            da.Fill(ds);
            c1DataGrid1.ItemsSource = ds.Tables["Employees"].AsDataView();
            c1DataGrid1.SelectionMode = C1.WPF.DataGrid.DataGridSelectionMode.MultiRange;
        }

        #region STEP I
        private DataTable GetTableOfSelectedRange(C1.WPF.DataGrid.C1DataGrid view)
        {
            // create a table containing the selection range
            DataTable resultTable = new DataTable();
            DataTable sourceTable = null;
           
            // create lists for selected row & column ranges
            var rowSel = c1DataGrid1.Selection.SelectedRows.ToList();
            var colSel = c1DataGrid1.Selection.SelectedColumns.ToList();

            if (view.ItemsSource is DataView)
                sourceTable = ((DataView)view.ItemsSource).Table;
            if (sourceTable != null)
            {
                for (int colHandle = 0; colHandle < colSel.Count; colHandle++)
                {
                    resultTable.Columns.Add(new DataColumn(colSel[colHandle].Name));
                }
                    for (int rowHandle = 0; rowHandle < rowSel.Count; rowHandle++)
                    {
                        ArrayList values = new ArrayList();
                        for (int colHandle = 0; colHandle < colSel.Count; colHandle++)
                        {
                            values.Add(colSel[colHandle].GetCellValue(rowSel[rowHandle]));
                        }
                            resultTable.Rows.Add(values.ToArray());
                        }
                resultTable.AcceptChanges();
            }
            return resultTable;
        }
        #endregion

        private void PrintGrid()
        {
            // if no rows are selected, then print the original grid
            if (this.c1DataGrid1.Selection.SelectedRows.Count == 0)
            {
                c1DataGrid1.Print("test");
            }
            else
            {
                #region STEP II
                // Create a CloneGrid
                C1.WPF.DataGrid.C1DataGrid clonedGrid = new C1DataGrid();

                // Add it to the Visual Tree
                grid1.Children.Add(clonedGrid);
                #endregion

                #region STEP III
                // Assign the cloneTable as the Itemsource for the cloneGrid 
                DataTable clonedTable = GetTableOfSelectedRange(c1DataGrid1);
                clonedGrid.ItemsSource = clonedTable.AsDataView();
                #endregion

                // Set the Column widths
                for (int i = 0; i < clonedGrid.Columns.Count; i++)
                {
                    clonedGrid.Columns[i].Width = new C1.WPF.DataGrid.DataGridLength(130, DataGridUnitType.Pixel);
                }

                #region STEP IV
                //Print the Grid
                clonedGrid.Print("test");
                #endregion
            }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            PrintGrid();
        }

       
    }
}
